%Test for dual tree 1D
%Test of perfect reconstruction

%*****************************************************
%* author: Caroline Chaux                            *
%* institution: Institut Gaspard Monge - CNRS	     *
%*	       Universit de Marne la Valle             *
%* date: Thursday, November, 2nd 2006                *
%* License CeCILL-B				      *
%*****************************************************


%description
disp('This program decomposes an image via a 1D dual-tree M-band transform and reconstructs the obtained coeffients.');

%wavelet choice
m='splines',
%number of bands of the filter bank 
M=2;
%decomposition levels
rm=4;

%signal to decompose
load('barbpgm.mat')
x=barb(1,:);

%Size adaptation
x=x(1:M^rm*floor(length(x)/M^rm));

%decomposition
[wp,wm,H,HH,G,Gh]=dualtreeM1D_freq(x,m,rm);

%reconstruction
xrec = idualtreeM1D_freq(wp,wm,rm,H,HH,G,Gh);

%norm computation
disp('Original signal norm:');
norm(x,'fro')
disp('Reconstructed signal norm:');
norm(xrec,'fro')
disp('Norm of the difference between the original signal and the reconstructed one:');
norm(x-xrec,'fro')

%plots
figure
plot(x)
title('Original signal')

figure
plot(xrec)
title('Reconstructed signal')

figure
plot(x-xrec)
title('Original signal minus reconstructed signal')

