function H = frsplis(N,r)
%H = frsplis(N,r) computes the frequency response of lowpass QMF filters
% corresponding to B-spline symmetric wavelets.
% N : number of samples,
% r : spline order,
% H : sampled frequency response.

% copyrights : J.-C. Pesquet - H. Krim
% Thursday, November, 2nd 2006

p = [1 0];
for k = 1:2*r-1
   dp = polyder(p);
   dlp = length(p)-length(dp)-1;
   dp = [zeros(1,dlp) dp];
   p = conv(dp,[-1 0 1])/k+conv([1 0],p);
end
w = 2*pi*(0:N-1)/N;
c = cos(w/2);
pc = polyval(p,c);
pc2 = polyval(p,cos(w));
H = c.^r.*sqrt(2*pc./pc2);
if rem(r,2)==1
   H = H.*exp(-j*w/2);
end


